(*
    CoMoEx - Example of inductive proofs: Gaussian equality
    Copyright (C) 2024  Max Ole Elliger

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *)

From Induction Require Export Multiplication.

(** In diesem File kann man zur Übung die Gauß'sche Summenformel beweisen. Dazu
   definieren wir zunächst das große Summenzeichen: *)

Fixpoint bigSum (n : NAT) : NAT :=
  match n with
  | zero => zero
  | succ n' => add (bigSum n') (succ n')
  end.

Definition two := succ (succ (zero)).

Theorem gauss :
  forall n,
    mul two (bigSum n) = mul n (succ n).
Proof.
Admitted.
